<?php
/*------------------------------------------------------------------------
# Copyright (C) 2012-2015 WebxSolution Ltd. All Rights Reserved.
# @license - GPLv2.0
# Author: WebxSolution Ltd
# Websites:  http://www.webxsolution.com
# Terms of Use: An extension that is derived from the JoomlaCK editor will only be allowed under the following conditions: http://joomlackeditor.com/terms-of-use
# ------------------------------------------------------------------------*/ 

defined('_JEXEC') or die('Restricted access');

class pkg_arkframeworkInstallerScript
{
	
	private $ajax_plugins = array
	(
		'inlinecontent',
		'inlinemodestatelistener'

	);
	
	private $content_plugins = array
	(
		'arkcontent',
		'arkfilter'
	);

	
	private $extension_plugins = array
	(
		'inline'
	);
	

	private $system_plugins = array
	(
		'inlinecontent',
		'arkversions',
		'modulehistory',
		'inlinehistory'
	);
	
	
	public function preflight($type, $parent)
	{
		//Workaround I shouldn't have to do
		$app 	= JFactory::getApplication();
		$db 	= JFactory::getDBO();
		
		$sql = $db->getQuery( true );
		$sql->select( '1' )
			->from('#__extensions')
			->where( '`name` = "com_arkeditor"' );
			
		if( !$db->setQuery( $sql )->loadResult() )
		{
			
	
			$sql = $db->getQuery( true ); //Delete if we still need to
			$sql->delete( '#__menu' )
				->where( '`title` like "COM_ARKEDITOR%"' );
			$db->setQuery( $sql )->query();
			
			//delete any files
			
			if(JFolder::exists(JPATH_SITE.'/components/com_arkeditor'))
				JFolder::delete(JPATH_SITE.'/components/com_arkeditor');
			if(JFolder::exists(JPATH_ADMINISTRATOR.'/components/com_arkeditor'))	
				JFolder::delete(JPATH_ADMINISTRATOR.'/components/com_arkeditor');
			
			
			//reset to install path
			$prop =  new ReflectionProperty('JInstallerAdapterPackage', 'route');
			$prop->setAccessible(true);
			$prop->setValue($parent,'install');

		}
		
	}
	
	
	public function postflight($parent)
	{
		$db = JFactory::getDBO();
		$app = JFactory::getApplication();

		//Publish ajax plugins

		$query = $db->getQuery(true);
		$query->update('#__extensions')
			->set('enabled = 1')
			->where('folder = '.$db->quote('ajax'))
			->where('element IN ('. $db->quote(implode($db->quote(','),$this->ajax_plugins),false).')');
		
		$db->setQuery($query);

		if(!$db->query())
		{
			$app->enqueueMessage( 'Failed to publish ajax plugins for ARK Framework' );
		}

		//Publish content plugins

		$query = $db->getQuery(true);
		$query->update('#__extensions')
			->set('enabled = 1')
			->set('ordering = -1')
			->where('folder = '.$db->quote('content'))
			->where('element IN ('. $db->quote(implode($db->quote(','),$this->content_plugins),false).')');	

		$db->setQuery($query);

		if(!$db->query())
			$app->enqueueMessage( 'Failed to publish content plugins for ARK' );
		
		
		$query = $db->getQuery(true);
		$query->update('#__extensions')
			->set('ordering = 9999')
			->where('folder = '.$db->quote('content'))
			->where('element = '.$db->quote('arkcontent'));	

		$db->setQuery($query);

		if(!$db->query())
			$app->enqueueMessage( 'Failed to update ordering field for arkcontent plugins for ARK Framework' );
		
		
		//Publish extension plugins

		$query = $db->getQuery(true);
		$query->update('#__extensions')
			->set('enabled = 1')
			->where('folder = '.$db->quote('extension'))
			->where('element IN ('. $db->quote(implode($db->quote(','),$this->extension_plugins),false).')');
			
		$db->setQuery($query);

		if(!$db->query())
			$app->enqueueMessage( 'Failed to publish extension plugins for ARK' );

		
		//Publish system plugins

		$query = $db->getQuery(true);
		$query->update('#__extensions')
			->set('enabled = 1')
			->where('folder = '.$db->quote('system'))
			->where('element IN ('. $db->quote(implode($db->quote(','),$this->system_plugins),false).')');

		$db->setQuery($query);

		if(!$db->query())
			$app->enqueueMessage( 'Failed to publish system plugins for ARK' );
		
		// @bug J3 > Doesn't Allow for Adding Files to the Package Installer for Adding Features on Update/Upgrade so Suppress Messages
		$queue = $app->getMessageQueue();

		if( count( $queue ) )
		{
			foreach( $queue as $key => $message )
			{
				// If We Find a Message Referring to the Above Bug
				if( JText::_( 'JLIB_INSTALLER_ERROR_NOTFINDXMLSETUPFILE' ) === $message['message'] && $message['type'] === 'warning' )
				{
					// Can't Get Hold of Queue Thanks to JLogger so Hide All Warning Messages (no unique css class)
					echo '<style>
							#system-message-container .alert { display : none; }
							#system-message-container .alert-block,
							#system-message-container .alert-success,
							#system-message-container .alert-info,
							#system-message-container .alert-danger,
							#system-message-container .alert-error { display : block; }
						</style>';

					break;
				}//end if
			}//end foreach
		}//end if
	}
}